package com.gmail.josemanuelgassin.DeathMessages;

import java.util.List;
import java.util.Random;

import org.apache.commons.lang.WordUtils;
import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.entity.Arrow;
import org.bukkit.entity.Blaze;
import org.bukkit.entity.CaveSpider;
import org.bukkit.entity.Creeper;
import org.bukkit.entity.Enderman;
import org.bukkit.entity.Entity;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Fireball;
import org.bukkit.entity.Ghast;
import org.bukkit.entity.Giant;
import org.bukkit.entity.IronGolem;
import org.bukkit.entity.PigZombie;
import org.bukkit.entity.Player;
import org.bukkit.entity.Projectile;
import org.bukkit.entity.Silverfish;
import org.bukkit.entity.Skeleton;
import org.bukkit.entity.Skeleton.SkeletonType;
import org.bukkit.entity.Snowball;
import org.bukkit.entity.Snowman;
import org.bukkit.entity.Spider;
import org.bukkit.entity.TNTPrimed;
import org.bukkit.entity.Wither;
import org.bukkit.entity.Wolf;
import org.bukkit.entity.Zombie;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityDamageByEntityEvent;
import org.bukkit.event.entity.EntityDamageEvent;
import org.bukkit.event.entity.EntityDamageEvent.DamageCause;
import org.bukkit.event.entity.PlayerDeathEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

class Listener_Jugador implements Listener{
_DeathMessages main;
Listener_Jugador(_DeathMessages instance){main = instance;}

private Random aleatorio;

//============================================= Generador Random
	String escogerMensajeAleatorio(String causa){
		aleatorio = new Random();
		List<String> MensajesPosibles = main.FC.getStringList(causa);
		int numeroAleatorio = aleatorio.nextInt(MensajesPosibles.size());
		return MensajesPosibles.get(numeroAleatorio);
	}
	
//============================================= Muerte
	@EventHandler(priority = EventPriority.MONITOR)
	void jugadorMuere(PlayerDeathEvent e){
		try{
			if(e.getDeathMessage().equals(""))return;
		}catch(NullPointerException ex){return;}
		// debug
		if(main.debug){
			try{
				Bukkit.broadcastMessage(ChatColor.GREEN + "Victim Name = " + e.getEntity().getName());
			}catch(Exception ex){
				Bukkit.broadcastMessage(ChatColor.RED + "Victim Name = NONE");
			}
			try{
				Bukkit.broadcastMessage(ChatColor.GREEN + "World Name = " + e.getEntity().getWorld().getName());
			}catch(Exception ex){
				Bukkit.broadcastMessage(ChatColor.RED + "World Name = NONE");
			}
			try{
				Bukkit.broadcastMessage(ChatColor.GREEN + "Last Damage Cause Type = " + e.getEntity().getLastDamageCause().getEventName());
			}catch(Exception ex){
				Bukkit.broadcastMessage(ChatColor.RED + "Last Damage Cause Type = NONE");
			}
			try{
				Bukkit.broadcastMessage(ChatColor.GREEN + "Last Damage Cause = " + e.getEntity().getLastDamageCause().getCause());
			}catch(Exception ex){
				Bukkit.broadcastMessage(ChatColor.RED + "Last Damage Cause = NONE");
			}
			try{
				Bukkit.broadcastMessage(ChatColor.GREEN + "Damager = " + ((EntityDamageByEntityEvent)e.getEntity().getLastDamageCause()).getDamager());
			}catch(Exception ex){
				Bukkit.broadcastMessage(ChatColor.RED + "Damager = NONE");
			}
		}
		// El mensaje será enviado mediante broadcast en lugar del evento
		e.setDeathMessage("");
		
		// Presuponemos que la causa de la muerte puede no ser obtenible
		String causa = "Unknown";
		
		Player v = e.getEntity();
		String vn = v.getName();
	
		// CAUSAS INDETERMINADAS "Unknown"
		if(v.getLastDamageCause() == null){
			if(main.mensajesPvP == 3)return;
			String MM = escogerMensajeAleatorio(causa).replaceAll("%world", v.getWorld().getName()).replaceAll("%player", vn);
			main.comunicadorDeMundos(main.formateador(MM), e.getEntity().getWorld().getName());
			return;
		}
		EntityDamageEvent ki = v.getLastDamageCause();
		DamageCause ca = ki.getCause();

		if(ki instanceof EntityDamageByEntityEvent){
			EntityDamageByEntityEvent kie = (EntityDamageByEntityEvent)ki;
			Entity damager = kie.getDamager();
			// ASESINO = JUGADOR
			if(damager instanceof Player){
				if(main.mensajesPvP == 1)return;
				
				// ASESINO = JUGADOR CON ENCANTAMIENTO THORNS
				if(ca == DamageCause.THORNS){
					causa = "Thorns";
					Player a = v.getKiller();
					String an = null;
					
					try{
						an = a.getName();
					}catch(NullPointerException ex){
						v.sendMessage(main.label + ChatColor.RED + "Other Server Plugin is causing conflics with Death Messages: The Death Cause is 'Thorns Enchantment' but plugin can't get the assasins name! This is caused when other plugin tries to use NPCs or Commands as Players.");
						return;
					}
					
					String MM = escogerMensajeAleatorio(causa).replaceAll("%world", v.getWorld().getName()).replaceAll("%killer", an).replaceAll("%player", vn);
					e.setDeathMessage(main.formateador(MM));
					main.comunicadorDeMundos(main.formateador(MM), e.getEntity().getWorld().getName());
					return;
				}
				
				// ASESINO = JUGADOR ADVERSARIO MELEE
				ItemStack it = ((Player) damager).getItemInHand();
				String matNom = (it != null) ? it.getType().toString() : "AIR";

				if(ca == DamageCause.ENTITY_ATTACK){
					if(matNom == "AIR")	causa = "PvPFist";
					else				causa = "PvPWeapon";
				}
				matNom = WordUtils.capitalize(matNom.toLowerCase().replaceAll("_", " "));
				
				Player a = v.getKiller();
				String an = null;
				try{
					an = a.getName();
				}catch(NullPointerException ex){
					v.sendMessage(main.label + ChatColor.RED + "Other Server Plugin is causing conflics with Death Messages: The Death Cause is 'PvP Melee Attack' but plugin can't get the assasins name! This is caused when other plugin tries to use NPCs or Commands as Players.");
					return;
				}
				
				String MM = escogerMensajeAleatorio(causa);
				String armaNom = null;
				
				if(MM.contains("%weapon_name")){
					ItemMeta metaD = it.getItemMeta();
					if(metaD.getDisplayName() != null){
						armaNom = metaD.getDisplayName();
						MM = MM.replaceAll("%weapon_name", armaNom);	
					}
				}
								
				if(MM.contains("%weapon_material") || armaNom == null)MM = MM.replaceAll("%weapon_material", matNom).replaceAll("%weapon_name", matNom);

				MM = MM.replaceAll("%world", v.getWorld().getName()).replaceAll("%killer", an).replaceAll("%player", vn);
				main.comunicadorDeMundos(main.formateador(MM), e.getEntity().getWorld().getName());
				return;
			}
			
			// ASESINO = MOB
			if(ca == DamageCause.ENTITY_ATTACK){
				if(main.mensajesPvP == 3)return;
				if(damager instanceof Creeper)										causa = "Creeper"; // temporal
				if(damager instanceof Zombie)										causa = "Zombie";
				if(damager instanceof Spider)										causa = "Spider";
				if(damager instanceof CaveSpider)									causa = "CaveSpider";
				if(damager instanceof Enderman)										causa = "Enderman";
				if(damager instanceof Silverfish)									causa = "Silverfish";
				if(damager.getType().equals(EntityType.MAGMA_CUBE))					causa = "MagmaCube";
				if(damager.getType().equals(EntityType.SLIME))						causa = "Slime";
				if(damager instanceof Wolf)											causa = "Wolf";
				if(damager instanceof PigZombie)									causa = "PigZombie";
				if(damager instanceof IronGolem)									causa = "IronGolem";
				if(damager instanceof Giant)										causa = "Giant";
				if(damager instanceof Wither)										causa = "Wither";
				if(damager.getType() == EntityType.SKELETON){
					Skeleton esqueleto = (Skeleton)damager;
					if(esqueleto.getSkeletonType().equals(SkeletonType.NORMAL))		causa = "SkeletonMelee";
					if(esqueleto.getSkeletonType().equals(SkeletonType.WITHER))		causa = "WitherSkeleton";
				}
			}

			else if(ca == DamageCause.PROJECTILE){
				Projectile pro = (Projectile) damager;

				// ASESINO = JUGADOR CON ARCO
				if(pro.getShooter() instanceof Player){
					if(main.mensajesPvP == 1)return;
					if(pro instanceof Arrow)	causa = "PvPBow";

					Player a = v.getKiller();
					String an = null;
					try{
						an = a.getName();
					}catch(NullPointerException ex){
						v.sendMessage(main.label + ChatColor.RED + "Other Server Plugin is causing conflics with Death Messages: The Death Cause is 'PvP Projectile Attack' but plugin can't get the assasins name! This is caused when other plugin tries to use NPCs or Commands as Players.");
						return;
					}
					
					String MM = escogerMensajeAleatorio(causa).replaceAll("%world", v.getWorld().getName()).replaceAll("%killer", an).replaceAll("%player", vn);
					main.comunicadorDeMundos(main.formateador(MM), e.getEntity().getWorld().getName());
					return;
				}
				// ASESINO = OTRAS CAUSAS DE PROYECTILES
				if(main.mensajesPvP == 3)return;
				else if(pro instanceof Arrow){
					if(pro.getShooter() instanceof Skeleton)	causa = "SkeletonArcher";
					else										causa = "DispenserArrow";

				}else if(pro instanceof Snowball){
					if(pro.getShooter() instanceof Snowman)		causa = "Snowman";
					
				}else if(pro instanceof Fireball){
					if(pro.getShooter() instanceof Ghast)		causa = "Ghast";
					else if(pro.getShooter() instanceof Blaze)	causa = "Blaze";
					else if(pro.getShooter() instanceof Wither)	causa = "Wither";
					else										causa = "DispenserFireball";
				}
			}

			if(main.mensajesPvP == 3)return;
			else if((ca == DamageCause.ENTITY_EXPLOSION) || (ca == DamageCause.BLOCK_EXPLOSION)){
				//if(damager instanceof Creeper)		causa = "Creeper";
				if(damager instanceof TNTPrimed)	causa = "TNT";
			}

		}
		else{
			if(ca == DamageCause.DROWNING)		causa = "Drowning";
			if(ca == DamageCause.STARVATION)	causa = "Starvation";
			if(ca == DamageCause.CONTACT)		causa = "Cactus";
			if(ca == DamageCause.CUSTOM)		causa = "Unknown";
			if(ca == DamageCause.FIRE)			causa = "FireBlock";
			if(ca == DamageCause.FIRE_TICK)		causa = "FireEffect";
			if(ca == DamageCause.LAVA)			causa = "Lava";
			if(ca == DamageCause.LIGHTNING)		causa = "Lightning";
			if(ca == DamageCause.POISON)		causa = "Poison";
			if(ca == DamageCause.SUFFOCATION)	causa = "Suffocation";
			if(ca == DamageCause.VOID)			causa = "Void";
			if(ca == DamageCause.FALL)			causa = "Fall";
			if(ca == DamageCause.SUICIDE)		causa = "Suicide";
			if(ca == DamageCause.MAGIC)			causa = "PotionofHarming";
			if(ca == DamageCause.WITHER)		causa = "WitherEffect";
			if(ca == DamageCause.FALLING_BLOCK)	causa = "Anvil";
		}

		String MM = escogerMensajeAleatorio(causa).replaceAll("%world", v.getWorld().getName()).replaceAll("%player", vn);
		main.comunicadorDeMundos(main.formateador(MM), e.getEntity().getWorld().getName());
	}
}