package com.gmail.josemanuelgassin.DeathMessages;

import java.io.File;
import java.util.logging.Level;

class Util_VersionChecker{
_DeathMessages main;
Util_VersionChecker(_DeathMessages instance){main = instance;}

//============================================= comprobar versi�n y guardar datos por defecto
	void configVersionChecker(){
		// variables
		String version = main.getConfig().getString("Version");
		boolean versionMala = false;
		
		// Si el fichero es inexistente o la versión diferente
		File conf = new File(main.getDataFolder() + "/config.yml");
		if(!main.pdfFile.getVersion().equals(version) || !conf.exists())versionMala = true;	
		if(versionMala){
			File oldconf = new File(main.getDataFolder() + "/old_config.yml");
			conf.renameTo(oldconf);
			conf.delete();
			main.getConfig().options().copyDefaults(true);
			main.saveDefaultConfig();
			main.logger.log(Level.WARNING, "<<[ " + main.pdfFile.getName() + " ]>> " + "Fichero 'config.yml' anticuado, renombrado a 'old_config.yml' y creado fichero actualizado.");
		}
	}
}